using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace WindowsGame1
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
    //    ContentManager Content;

        public Texture2D backgroundTexture, Blue_ShipTexture, bullet_texture, EnemyRep_texture;
        public Rectangle viewportRect;
        SpriteBatch spriteBatch;

        GameObject Blue_Ship;
        
        GamePadState previousGamePadState = GamePad.GetState(PlayerIndex.One);
        KeyboardState previousKeyboardState = Keyboard.GetState();

        public int BorderTop = 12;
        public int BorderLeft = 30;
        public int BorderBottom = 580;
        public int BorderRight = 770;

        const int maxEnemiesR = 12;
        const float maxEnemyRHeight = 0.01f;
        const float minEnemyRHeight = 0.90f;
        const float maxEnemyRVelocity = 9.0f;
        const float minEnemyRVelocity = 12.0f;

        const int maxEnemiesE = 6;
        const float maxEnemyEHeight = 0.01f;
        const float minEnemyEHeight = 0.90f;
        const float maxEnemyEVelocity = 12.0f;
        const float minEnemyEVelocity = 18.0f;

        const int maxBossR = 1;
        const float maxBossRHeight = 0.02f;
        const float minBossRHeight = 0.84f;
        const float maxBossRHeightH = 0.2f;
        const float minBossRHeightH = 0.4f;
        const float maxBossRVelocity = 2.5f;
        const float minBossRVelocity = 2.5f;
        int BossRlife = 0;

        List<GameObject> objects = new List<GameObject>();

        public Random random = new Random();
        
        int score;
        SpriteFont font;
        Vector2 scoreDrawPoint = new Vector2(0.25f, 0.01f);

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
        //    Content = new ContentManager(Services, "Content");
            Content.RootDirectory = "Content";
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related Content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {

            base.Initialize();

            // TODO: Add your initialization logic here
            spriteBatch = new SpriteBatch(graphics.GraphicsDevice);

            Blue_Ship = new PlayerShip(this);

            objects.Add(Blue_Ship);

            Blue_Ship.position = new Vector2(180, graphics.GraphicsDevice.Viewport.Height - 300);

        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your Content.
        /// </summary>
        protected override void LoadContent()
        {
            backgroundTexture = Content.Load<Texture2D>(@"Sprites/Stars");
            Blue_ShipTexture = Content.Load<Texture2D>(@"Sprites/Blue_Ship");
            bullet_texture = Content.Load<Texture2D>(@"Sprites/Bullet_B");
            EnemyRep_texture = Content.Load<Texture2D>(@"Sprites/EnemyRep");

            /*enemiesR = new GameObject[maxEnemiesR];
            enemiesR[0] = new GameObject(Content.Load<Texture2D>(@"Sprites/EnemyRep"));
            
            enemiesE = new GameObject[maxEnemiesE];
            enemiesE[0] = new GameObject(Content.Load<Texture2D>(@"Sprites/EnemyEye"));
            
            bosssR = new GameObject[maxBossR];
            bosssR[0] = new GameObject(Content.Load<Texture2D>(@"Sprites/BossRep"));
            */

            font = Content.Load<SpriteFont>(@"Fonts/GameFont");

            viewportRect = new Rectangle(0, 0, graphics.GraphicsDevice.Viewport.Width, graphics.GraphicsDevice.Viewport.Height);
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            // TODO: use this.Content to load your game Content here
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all Content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager Content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed ||
                Keyboard.GetState().IsKeyDown(Keys.Escape))
                this.Exit();
            // TODO: Add your update logic here
            //Xbox Controller

            Blue_Ship.rotation = MathHelper.Clamp(Blue_Ship.rotation, -MathHelper.PiOver4, MathHelper.PiOver4);

          /*  if (gamePadState.Buttons.A == ButtonState.Pressed)
            {
                GamePad.SetVibration(PlayerIndex.One, 0.5f, 0.5f);
                FireBulletB();
            }
            else
            {
                GamePad.SetVibration(PlayerIndex.One, 0f, 0f);
            }*/

/*            if (keyboardState.IsKeyDown(Keys.Space) && previousKeyboardState.IsKeyUp(Keys.Space))
            {
                FireBulletB();
            }*/

            List<GameObject> objs = new List<GameObject>(objects);

            foreach (GameObject o in objs)
            {
                o.Update(gameTime);
                if (!o.alive)
                    objects.Remove(o);
            }

            foreach(GameObject a in objects) foreach (GameObject b in objects)
            {
                if (a.team == b.team) continue;
                Rectangle ar = a.GetBounds();
                Rectangle br = b.GetBounds();
                if (ar.Intersects(br)) {
                    a.CollideWith(b);
                }
            }

            // makeshift game logic
            int enemies = 0;
            foreach (GameObject o in objs)
                if (o is Enemy)
                    enemies++;
            if (enemies < 3)
            {
                Enemy e = new Enemy(this);
                e.position = new Vector2(BorderRight, (float)random.NextDouble()*BorderBottom);
                AddObject(e);
            }



            previousGamePadState = GamePad.GetState(PlayerIndex.One);
            previousKeyboardState = Keyboard.GetState();
        
            base.Update(gameTime);
        }
        /*
        public void UpdateEnemiesR()
        {
            foreach (GameObject enemyR in enemiesR)
            {
                if (null == enemyR) continue;
                if (!enemyR.alive)
                {
                    enemyR.position += enemyR.velocity;
                    if (!viewportRect.Contains(new Point((int)enemyR.position.X, (int)enemyR.position.Y)))
                    {
                        enemyR.alive = false;
                    }          
                }
                else
                {
                    enemyR.alive = true;
                    enemyR.position = new Vector2(viewportRect.Right, MathHelper.Lerp((float)viewportRect.Height * minEnemyRHeight, (float)viewportRect.Height * maxEnemyRHeight, (float)random.NextDouble()));
                    enemyR.velocity = new Vector2(MathHelper.Lerp(-minEnemyRVelocity, -maxEnemyRVelocity, (float)random.NextDouble()), 0);
                }
            }
        }

        public void UpdateEnemiesE()
        {
            foreach (GameObject enemyE in enemiesE)
            {
                if (null == enemyE) continue;
                if (!enemyE.alive)
                {
                    enemyE.position += enemyE.velocity;
                    if (!viewportRect.Contains(new Point((int)enemyE.position.X, (int)enemyE.position.Y)))
                    {
                        enemyE.alive = false;
                    }
                }
                else
                {
                    enemyE.alive = true;
                    enemyE.position = new Vector2(viewportRect.Right, MathHelper.Lerp((float)viewportRect.Height * minEnemyEHeight, (float)viewportRect.Height * maxEnemyEHeight, (float)random.NextDouble()));
                    enemyE.velocity = new Vector2(MathHelper.Lerp(-minEnemyEVelocity, -maxEnemyEVelocity, (float)random.NextDouble()), 0);
                }
            }
        }

        public void UpdateBossR()
        {
            foreach (GameObject bossR in bosssR)
            {
                if (null == bossR) continue;
                if (!bossR.alive)
                {
                    bossR.position += bossR.velocity;
                    if (!viewportRect.Contains(new Point((int)bossR.position.X, (int)bossR.position.Y)))
                    {
                        bossR.alive = false;
                    }
                }
                else
                {
                    bossR.alive = true;
                    bossR.position = new Vector2(viewportRect.Right, MathHelper.Lerp((float)viewportRect.Height * minBossRHeight, (float)viewportRect.Height * maxBossRHeight, (float)random.NextDouble()));
                    bossR.velocity = new Vector2(MathHelper.Lerp(-minBossRVelocity, -maxBossRVelocity, (float)random.NextDouble()), 0);
                }
            }
        }

        public void FireBulletB()
        {
            foreach (GameObject ball in bulletsB)
            {
                if (null != ball && !ball.alive)
                {
                    ball.alive = true;
                    ball.position = Blue_Ship.position;

                    ball.velocity = new Vector2((float)Math.Cos(Blue_Ship.rotation), (float)Math.Sin(Blue_Ship.rotation)) * 12.0f;
                    return;
                }
            }
        }

        public void UpdateBulletsB()
        {
            foreach (GameObject ball in bulletsB)
            {
                if (null == ball || !ball.alive) continue;

                ball.position += ball.velocity;
                if (!viewportRect.Contains(new Point((int)ball.position.X, (int)ball.position.Y)))
                {
                    ball.alive = false;
                    continue;
                }
                Rectangle bulletBRect = new Rectangle((int)ball.position.X, (int)ball.position.Y, ball.sprite.Width, ball.sprite.Height);
                foreach(GameObject enemyR in enemiesR)
                {
                    if (null == enemyR) continue;
                    Rectangle enemyRRect = new Rectangle((int)enemyR.position.X, (int)enemyR.position.Y, enemyR.sprite.Width, enemyR.sprite.Height);
                    if(bulletBRect.Intersects(enemyRRect))
                    {
                        ball.alive = false;
                        enemyR.alive = false;
                        
                        score += 612;

                        break;
                    }
                }
                foreach (GameObject enemyE in enemiesE)
                {
                    if (null == enemyE) continue;
 
                    Rectangle enemyERect = new Rectangle((int)enemyE.position.X, (int)enemyE.position.Y, enemyE.sprite.Width, enemyE.sprite.Height);
                    if (bulletBRect.Intersects(enemyERect))
                    {
                        ball.alive = false;
                        enemyE.alive = false;

                        score += 612;

                        break;
                    }
                }
                foreach (GameObject bossR in bosssR)
                {
                    if (null == bossR) continue;

                    Rectangle bossRRect = new Rectangle((int)bossR.position.X, (int)bossR.position.Y, bossR.sprite.Width, bossR.sprite.Height);
                    if (bulletBRect.Intersects(bossRRect))
                    {
                        
                        ball.alive = false;
                        BossRlife++;
                        
                        if (BossRlife == 8)
                        {
                            bossR.alive = false;
                        }

                        score += 1212;

                        break;
                    }
                }
            }
        }
        */
        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            graphics.GraphicsDevice.Clear(Color.CornflowerBlue);

            spriteBatch.Begin(SpriteBlendMode.AlphaBlend);
            
            spriteBatch.Draw(backgroundTexture, viewportRect, Color.White);

            foreach (GameObject o in objects)
                o.Draw(spriteBatch);

            spriteBatch.DrawString(font, "Gallons of Alien Blood Spilt: " + score.ToString(), new Vector2(scoreDrawPoint.X * viewportRect.Width, scoreDrawPoint.Y * viewportRect.Height), Color.Red);

            spriteBatch.End();

            base.Draw(gameTime);
        }

        internal void AddObject(GameObject o)
        {
            objects.Add(o);
        }
    }
}
