using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace WindowsGame1
{
    class PlayerShip : GameObject
    {
        float lastFire;

        public PlayerShip(Game1 game)
            : base(game.Blue_ShipTexture, game)
        {
            lastFire = 0;
            team = Team.friendly;
        }

        public override void Update(Microsoft.Xna.Framework.GameTime time)
        {
            GamePadState gamePadState = GamePad.GetState(PlayerIndex.One);
            
            position.X += gamePadState.ThumbSticks.Left.X * 6.0f;
            position.Y -= gamePadState.ThumbSticks.Left.Y * 6.0f;
            //Keyboard
            KeyboardState keyboardState = Keyboard.GetState();

            if(keyboardState.IsKeyDown(Keys.Left))
            {
                    position.X -= 6.0f;
            }
            if(keyboardState.IsKeyDown(Keys.Right))
            {
                    position.X += 6.0f;
            }
            if(keyboardState.IsKeyDown(Keys.Up))
            {
                    position.Y -= 6.0f;
            }
            if(keyboardState.IsKeyDown(Keys.Down))
            {
                    position.Y += 6.0f;
            }

            if (position.X < game.BorderLeft) position.X = game.BorderLeft;
            if (position.X > game.BorderRight) position.X = game.BorderRight;
            if (position.Y < game.BorderTop) position.Y = game.BorderTop;
            if (position.Y > game.BorderBottom) position.Y = game.BorderBottom;

            if (gamePadState.Buttons.A == ButtonState.Pressed || keyboardState.IsKeyDown(Keys.Space))
            {
                if (time.TotalGameTime.TotalSeconds > lastFire + 0.3333f)
                {
                    Bullet b = new Bullet(game, Team.friendly);
                    b.position = position;
                    b.velocity = new Vector2(600,0);
                    game.AddObject(b);
                    lastFire = (float)time.TotalGameTime.TotalSeconds;
                }
            }
        }

        public override void CollideWith(GameObject other)
        {
            if (!ImportantCollision(other)) return;
            
            // reduce health or something
        }
    }
}
